// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dataspeed_ulc_msgs:msg/UlcCmd.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__TRAITS_HPP_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__TRAITS_HPP_

#include "dataspeed_ulc_msgs/msg/detail/ulc_cmd__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const dataspeed_ulc_msgs::msg::UlcCmd & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: clear
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "clear: ";
    value_to_yaml(msg.clear, out);
    out << "\n";
  }

  // member: enable_pedals
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enable_pedals: ";
    value_to_yaml(msg.enable_pedals, out);
    out << "\n";
  }

  // member: enable_steering
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enable_steering: ";
    value_to_yaml(msg.enable_steering, out);
    out << "\n";
  }

  // member: enable_shifting
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enable_shifting: ";
    value_to_yaml(msg.enable_shifting, out);
    out << "\n";
  }

  // member: shift_from_park
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shift_from_park: ";
    value_to_yaml(msg.shift_from_park, out);
    out << "\n";
  }

  // member: coast_decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "coast_decel: ";
    value_to_yaml(msg.coast_decel, out);
    out << "\n";
  }

  // member: linear_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_velocity: ";
    value_to_yaml(msg.linear_velocity, out);
    out << "\n";
  }

  // member: accel_cmd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accel_cmd: ";
    value_to_yaml(msg.accel_cmd, out);
    out << "\n";
  }

  // member: linear_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_accel: ";
    value_to_yaml(msg.linear_accel, out);
    out << "\n";
  }

  // member: linear_decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_decel: ";
    value_to_yaml(msg.linear_decel, out);
    out << "\n";
  }

  // member: jerk_limit_throttle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "jerk_limit_throttle: ";
    value_to_yaml(msg.jerk_limit_throttle, out);
    out << "\n";
  }

  // member: jerk_limit_brake
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "jerk_limit_brake: ";
    value_to_yaml(msg.jerk_limit_brake, out);
    out << "\n";
  }

  // member: yaw_command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw_command: ";
    value_to_yaml(msg.yaw_command, out);
    out << "\n";
  }

  // member: angular_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angular_accel: ";
    value_to_yaml(msg.angular_accel, out);
    out << "\n";
  }

  // member: lateral_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_accel: ";
    value_to_yaml(msg.lateral_accel, out);
    out << "\n";
  }

  // member: steering_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_mode: ";
    value_to_yaml(msg.steering_mode, out);
    out << "\n";
  }

  // member: pedals_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedals_mode: ";
    value_to_yaml(msg.pedals_mode, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const dataspeed_ulc_msgs::msg::UlcCmd & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<dataspeed_ulc_msgs::msg::UlcCmd>()
{
  return "dataspeed_ulc_msgs::msg::UlcCmd";
}

template<>
inline const char * name<dataspeed_ulc_msgs::msg::UlcCmd>()
{
  return "dataspeed_ulc_msgs/msg/UlcCmd";
}

template<>
struct has_fixed_size<dataspeed_ulc_msgs::msg::UlcCmd>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dataspeed_ulc_msgs::msg::UlcCmd>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dataspeed_ulc_msgs::msg::UlcCmd>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_CMD__TRAITS_HPP_
