// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dataspeed_ulc_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__TRAITS_HPP_
#define DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__TRAITS_HPP_

#include "dataspeed_ulc_msgs/msg/detail/ulc_report__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const dataspeed_ulc_msgs::msg::UlcReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: pedals_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedals_enabled: ";
    value_to_yaml(msg.pedals_enabled, out);
    out << "\n";
  }

  // member: steering_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_enabled: ";
    value_to_yaml(msg.steering_enabled, out);
    out << "\n";
  }

  // member: coasting
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "coasting: ";
    value_to_yaml(msg.coasting, out);
    out << "\n";
  }

  // member: speed_preempted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_preempted: ";
    value_to_yaml(msg.speed_preempted, out);
    out << "\n";
  }

  // member: steering_preempted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_preempted: ";
    value_to_yaml(msg.steering_preempted, out);
    out << "\n";
  }

  // member: override_latched
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override_latched: ";
    value_to_yaml(msg.override_latched, out);
    out << "\n";
  }

  // member: timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timeout: ";
    value_to_yaml(msg.timeout, out);
    out << "\n";
  }

  // member: steering_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_mode: ";
    value_to_yaml(msg.steering_mode, out);
    out << "\n";
  }

  // member: pedals_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedals_mode: ";
    value_to_yaml(msg.pedals_mode, out);
    out << "\n";
  }

  // member: speed_ref
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_ref: ";
    value_to_yaml(msg.speed_ref, out);
    out << "\n";
  }

  // member: speed_meas
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_meas: ";
    value_to_yaml(msg.speed_meas, out);
    out << "\n";
  }

  // member: accel_ref
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accel_ref: ";
    value_to_yaml(msg.accel_ref, out);
    out << "\n";
  }

  // member: accel_meas
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accel_meas: ";
    value_to_yaml(msg.accel_meas, out);
    out << "\n";
  }

  // member: max_steering_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_steering_angle: ";
    value_to_yaml(msg.max_steering_angle, out);
    out << "\n";
  }

  // member: max_steering_vel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_steering_vel: ";
    value_to_yaml(msg.max_steering_vel, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const dataspeed_ulc_msgs::msg::UlcReport & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<dataspeed_ulc_msgs::msg::UlcReport>()
{
  return "dataspeed_ulc_msgs::msg::UlcReport";
}

template<>
inline const char * name<dataspeed_ulc_msgs::msg::UlcReport>()
{
  return "dataspeed_ulc_msgs/msg/UlcReport";
}

template<>
struct has_fixed_size<dataspeed_ulc_msgs::msg::UlcReport>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dataspeed_ulc_msgs::msg::UlcReport>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dataspeed_ulc_msgs::msg::UlcReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATASPEED_ULC_MSGS__MSG__DETAIL__ULC_REPORT__TRAITS_HPP_
